<template>
  <v-row no-gutters>
    <v-col class="ma-5">
      <title-zone
        class="mb-10"
        :title="title"
        :state="shipment.state"
      />
      <shipment-info />
      <shipment-extra-details class="mt-10" />
    </v-col>
  </v-row>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import TitleZone from '~/components/Common/Page/TitleZone';
import { hashId } from '~/helpers/format/ids';
import ShipmentInfo from '~/components/Storage/Shipments/Details/Info';
import ShipmentExtraDetails from '~/components/Storage/Shipments/Details/Extra';

export default {
  name: 'ShipmentDetails',
  components: {
    TitleZone,
    ShipmentInfo,
    ShipmentExtraDetails,
  },
  data() {
    return {
      loading: false,
    };
  },
  computed: {
    shipmentId() {
      return this.$route.params.id;
    },
    title() {
      return `Envío de mercadería ${hashId({ id: this.shipmentId })}`;
    },
    ...mapState({
      shipment: state => state.storage.shipments.current.shipment,
    }),
  },
  async mounted() {
    await this.getShipmentDetails();
  },
  methods: {
    ...mapActions({
      getShipment: 'storage/shipments/getShipmentDetails',
    }),
    async getShipmentDetails() {
      try {
        this.loading = true;
        await this.getShipment({ shipmentId: this.shipmentId });
      } catch (e) {
        console.error(e);
      }
      this.loading = false;
    },
  },
};
</script>
